Index: Fl_BMP_Image.cxx
===================================================================
--- Fl_BMP_Image.cxx	(revision 4296)
+++ Fl_BMP_Image.cxx	(working copy)
@@ -85,6 +85,7 @@
   uchar		*ptr;		// Pointer into pixels
   uchar		colormap[256][3];// Colormap
   uchar		havemask = 0;	// single bit mask follows image data
+  bool		use_5_6_5 = false;// Use 5:6:5 for R:G:B channels in 16 bit images
 
   // Open the file...
   if ((fp = fopen(bmp, "rb")) == NULL) return;
@@ -170,6 +171,10 @@
     if (info_size > 12) getc(fp);
   }
 
+  // Read first dword of colormap. It tells us if 5:5:5 or 5:6:5 for 16 bit
+  if (depth == 16)
+    use_5_6_5 = (read_dword(fp) == 0xf800);
+
   // Setup image and buffers...
   d(bDepth);
   if (offbits) fseek(fp, offbits, SEEK_SET);
@@ -342,18 +347,18 @@
 	  }
           break;
 
-      case 16 : // 16-bit 5:5:5 RGB
+      case 16 : // 16-bit 5:5:5 or 5:6:5 RGB
           for (x = w(); x > 0; x --, ptr += bDepth) {
 	    uchar b = getc(fp), a = getc(fp) ;
-#ifdef USE_5_6_5 // Green as the brightest color should have one bit more 5:6:5
-	    ptr[0] = (uchar)(( b << 3 ) & 0xf8);
-	    ptr[1] = (uchar)(((a << 5) & 0xe0) | ((b >> 3) & 0x1c));
-	    ptr[2] = (uchar)(a & 0xf8);
-#else // this is the default wasting one bit: 5:5:5
-	    ptr[2] = (uchar)((b << 3) & 0xf8);
-	    ptr[1] = (uchar)(((a << 6) & 0xc0) | ((b >> 2) & 0x38));
-	    ptr[0] = (uchar)((a<<1) & 0xf8);
-#endif
+	    if (use_5_6_5) {
+		ptr[2] = (uchar)(( b << 3 ) & 0xf8);
+		ptr[1] = (uchar)(((a << 5) & 0xe0) | ((b >> 3) & 0x1c));
+		ptr[0] = (uchar)(a & 0xf8);
+	    } else {
+		ptr[2] = (uchar)((b << 3) & 0xf8);
+		ptr[1] = (uchar)(((a << 6) & 0xc0) | ((b >> 2) & 0x38));
+		ptr[0] = (uchar)((a<<1) & 0xf8);
+	    }
 	  }
 
           // Read remaining bytes to align to 32 bits...
